/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ MMR,TWR / I/O^RAMfBXN ]
 */

#ifndef _mmr_h_
#define _mmr_h_

#ifdef __cplusplus
extern "C" {
#endif
/*
 *	vGg
 */
BOOL FASTCALL mmr_init(void);
										/*  */
void FASTCALL mmr_cleanup(void);
										/* N[Abv */
void FASTCALL mmr_reset(void);
										/* Zbg */
BOOL FASTCALL mmr_trans_twr(WORD addr, DWORD *taddr);
										/* TWRAhXϊ */
DWORD FASTCALL mmr_trans_mmr(WORD addr);
										/* MMRAhXϊ */
DWORD FASTCALL mmr_trans_phys_to_logi(DWORD target);
										/* _AhXϊ */
BOOL FASTCALL mmr_readb(WORD addr, BYTE *dat);
										/* ǂݏo */
BOOL FASTCALL mmr_writeb(WORD addr, BYTE dat);
										/*  */
BOOL FASTCALL mmr_extrb(WORD *addr, BYTE *dat);
										/* MMRoRǂݏo */
BOOL FASTCALL mmr_extbnio(WORD *addr, BYTE *dat);
										/* MMRoRǂݏo(I/OȂ) */
BOOL FASTCALL mmr_extwb(WORD *addr, BYTE dat);
										/* MMRoR */
BOOL FASTCALL mmr_save(int fileh);
										/* Z[u */
BOOL FASTCALL mmr_load(int fileh, int ver);
										/* [h */

/*
 *	v[N
 */
extern BOOL mmr_flag;
										/* MMRLtO */
extern BYTE mmr_seg;
										/* MMRZOg */
extern BOOL mmr_modify;
										/* MMRԕύXtO */
#if XM7_VER >= 3
extern BYTE mmr_reg[0x80];
										/* MMRWX^ */
extern BOOL mmr_ext;
										/* gMMRLtO */
extern BOOL mmr_fastmode;
										/* MMRtO */
extern BOOL mmr_extram;
										/* gRAMLtO */
extern BOOL mmr_fast_refresh;
										/* tbVtO */
extern BOOL twr_fastmode;
										/* TWR[h */
extern BOOL mmr_768kbmode;
										/* MMR[h(TRUE=768KB,FALSE=256KB) */
extern BOOL dsp_400linetiming;
										/* 400C^C~Oo̓tO */
#else
extern BYTE mmr_reg[0x40];
										/* MMRWX^ */
#endif
#if XM7_VER == 1
extern BYTE bnk_reg;
										/* gRAMoNZNgWX^ */
extern BOOL mmr_64kbmode;
										/* MMR[h (TRUE=64KB,FALSE=192KB) */
#endif

extern BOOL twr_flag;
										/* TWRLtO */
extern BYTE twr_reg;
										/* TWRWX^ */
#ifdef __cplusplus
}
#endif

#endif	/* _mmr_h_ */
