/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ TuCPURg[ ]
 *
 *	RHG
 *	  2001.07.27		display_setpointer(display_setparam)̎dlύXɔ
 *						ύX
 *	  2001.08.14		BUSYM̒xs悤ɕύX
 *	  2001.08.27		ʃ[h؂ւ̕svȍĕ`}
 *	  2001.09.02		TuoN؂ւALŨZbgǉ
 *	  2001.11.24		TuHALT^C~OύX
 *	  2001.04.01		Xe[gt@CVer7.01̃[hɎsC
 *	  2002.12.04		zbgZbgp̍׍Hǉ
 *	  2003.03.29		Xe[g[h̃TuI/FWX^̕AɑΉ
 *	  2003.06.02		CLR߂BUSYtO𗎂ƂƃfbhbNɑΏ
 *	  2003.11.21		$FD04 bit5(ROMڑ̐؂芷@\)ɑΉ
 */

#include <string.h>
#include "xm7.h"
#include "keyboard.h"
#include "subctrl.h"
#include "device.h"
#include "display.h"
#include "aluline.h"
#include "ttlpalet.h"
#include "multipag.h"
#include "fdc.h"
#include "mmr.h"
#include "kanji.h"

/*
 *	O[o [N
 */
BOOL subhalt_flag;						/* TuHALTtO */
BOOL subbusy_flag;						/* TuBUSYtO */
BOOL subcancel_flag;					/* TuLZtO */
BOOL subattn_flag;						/* TuAeVtO */
BOOL subhalt_request;					/* TuHALTNGXgtO */
BOOL subcancel_request;					/* TuLZNGXgtO */
BYTE shared_ram[0x80];					/* LRAM */
BOOL subreset_flag;						/* TuċNtO */
BYTE busy_CLR_count;					/* BUSY($D40A) CLRߎsJE^ */
#if XM7_VER >= 2
BOOL mode320;							/* 320x200[h */
#if XM7_VER >= 3
BOOL mode400l;							/* 640x400[h */
BOOL mode256k;							/* 26F[h */
BOOL subram_protect;					/* Tuj^RAMveNg */
BOOL subreset_halt;						/* HALTċNtO */
BYTE subif_dat;							/* TuI/FWX^ ʃ[hۑ */
BOOL subkanji_flag;						/* ROM TuCPUڑtO */
BOOL submode_fix;						/* FM77AVpOS-9΍tO */
#endif
#endif
#if XM7_VER == 1
BOOL paritymode;						/* FM-8[hpeBtO */
#ifdef L4CARD
BOOL select_400line;					/* C400CItO */
BOOL subkanji_flag;						/* ROM TuCPUڑtO */
#endif
#endif


/*
 *	TuCPURg[
 *	
 */
BOOL FASTCALL subctrl_init(void)
{
#if XM7_VER == 3
	submode_fix = FALSE;
#endif
#if XM7_VER == 1
	paritymode = TRUE;
#endif

	return TRUE;
}

/*
 *	TuCPURg[
 *	N[Abv
 */
void FASTCALL subctrl_cleanup(void)
{
}

/*
 *	TuCPURg[
 *	Zbg
 */
void FASTCALL subctrl_reset(void)
{
	subhalt_request = FALSE;
	subhalt_flag = FALSE;
	subbusy_flag = TRUE;
	subcancel_request = FALSE;
	subcancel_flag = FALSE;
	subattn_flag = FALSE;
	subreset_flag = FALSE;
	busy_CLR_count = 0;
#if XM7_VER >= 2
	mode320 = FALSE;
#if XM7_VER >= 3
	mode400l = FALSE;
	mode256k = FALSE;
	screen_mode = SCR_200LINE;
	subram_protect = TRUE;
	subreset_halt = FALSE;
	subkanji_flag = FALSE;
	subif_dat = 0x08;
#endif
#endif

#if XM7_VER == 1 && defined(L4CARD)
	select_400line = FALSE;
	enable_400line = FALSE;
	subkanji_flag = FALSE;
#endif

	memset(shared_ram, 0xff, sizeof(shared_ram));
}

/*
 *	TuCPURg[
 *	HALT/CANCEL ANmbW
 */
void FASTCALL subctrl_halt_ack(void)
{
	subhalt_flag = subhalt_request;
	subcancel_flag = subcancel_request;

	/* HALTɂBUSYMONɂ */
	if (subhalt_request) {
		subbusy_flag = TRUE;
	}
}

/*
 *	TuCPURg[
 *	PoCgǂݏo
 */
BOOL FASTCALL subctrl_readb(WORD addr, BYTE *dat)
{
	BYTE ret;

	switch (addr) {
		/* TuCPU AeV荞݁ABreakL[荞 */
		case 0xfd04:
			/* BUSYtO */
			if (subbusy_flag) {
				ret = 0xff;
			}
			else {
				ret = 0x7f;
			}
			/* AeVtO */
			if (subattn_flag) {
				ret &= ~0x01;
				subattn_flag = FALSE;
			}
			/* BreakL[tO */
			if (break_flag || hotreset_flag) {
				ret &= ~0x02;

				/* zbgZbg */
				if (hotreset_flag) {
#if XM7_VER >= 2
					/* CjVG[^ROMȂzbgZbg */
					if (!initrom_en) {
						break_flag = FALSE;
						hotreset_flag = FALSE;
					}
#else
					break_flag = FALSE;
					hotreset_flag = FALSE;
#endif
				}
			}

#if XM7_VER == 1
			/* FM-8̃peBG[ */
			if ((fm_subtype == FMSUB_FM8) && !paritymode) {
				ret &= ~0x04;
			}
#endif

#if XM7_VER == 3
			/* FM77AVpOS-9΍tȌ */
			if (submode_fix) {
				ret &= ~0x10;
			}
#endif

#if XM7_VER == 1 && defined(L4CARD)
			/* ȉAFM-77[ĥݗL */
			if (fm_subtype == FMSUB_FM77) {
				/* ROM؂芷 */
				if (subkanji_flag) {
					ret &= ~0x20;
				}

				/* 400CJ[h */
				if (enable_400linecard) {
					ret &= ~0x10;
				}

				/* 400CJ[h[h */
				if (enable_400linecard && select_400line) {
					ret &= ~0x08;
				}
			}
#endif

			*dat = ret;
			maincpu_firq();
			return TRUE;

		/* TuC^tF[X */
		case 0xfd05:
			if (subbusy_flag) {
				ret = 0xfe;
			}
			else {
				ret = 0x7e;
			}

			*dat = ret;
			return TRUE;

		/* Tu[hXe[^X */
#if XM7_VER >= 2
		case 0xfd12:
			ret = 0xff;
			if (fm7_ver >= 2) {
				/* 320/640 */
				if (!mode320) {
					ret &= ~0x40;
				}

				/* uNXe[^X */
				if (blank_flag) {
					ret &= ~0x02;
				}
				/* VSYNCXe[^X */
				if (!vsync_flag) {
					ret &= ~0x01;
				}
			}
			*dat = ret;
			return TRUE;

		/* TuoN؂ւ(Write Only) */
		case 0xfd13:
			*dat = 0xff;
			return TRUE;
#endif
	}

	return FALSE;
}

/*
 *	TuCPURg[
 *	PoCg
 */
BOOL FASTCALL subctrl_writeb(WORD addr, BYTE dat)
{
	switch (addr) {
#if XM7_VER >= 3
		/* TuC^tF[X AV40g */
		case 0xfd04:
			if (fm7_ver >= 3) {
				/* bit2:Tuj^veNg */
				if (dat & 0x04) {
					subram_protect = FALSE;
				}
				else {
					subram_protect = TRUE;
				}
				/* bit3:400C[hI */
				if (dat & 0x08) {
					mode400l = FALSE;
				}
				else {
					mode400l = TRUE;
				}
				/* bit4:26F[hI */
				/*      bit34̗ONꍇAmode400lD */
				if ((dat & 0x10) && !mode400l) {
					mode256k = TRUE;
				}
				else {
					mode256k = FALSE;
				}
				/* bit5:ROMڑ؂芷 */
				if (dat & 0x20) {
					subkanji_flag = FALSE;
				}
				else {
					subkanji_flag = TRUE;
				}

				/* ʃ[h؂ւꍇĕ` */
				if ((BYTE)(dat & 0x18) != subif_dat) {
					display_setpointer(TRUE);
				}
				subif_dat = (BYTE)(dat & 0x18);
			}
			return TRUE;
#endif

#if XM7_VER == 1 && defined(L4CARD)
		/* TuC^tF[X FM-77g */
		case 0xfd04:
			/* ȉAFM-77[ĥݗL */
			if (fm_subtype == FMSUB_FM77) {
				/* bit3:400CJ[h[h */
				if (dat & 0x08) {
					select_400line = FALSE;
				}
				else {
					select_400line = TRUE;
				}

				/* bit5:ROMڑ؂芷 */
				if (dat & 0x20) {
					subkanji_flag = FALSE;
				}
				else {
					subkanji_flag = TRUE;
				}
			}
			return TRUE;
#endif

		/* TuRg[ */
		case 0xfd05:
#if XM7_VER == 1 && defined(Z80CARD)
			if (dat & 0x01) {
				if (!main_z80mode) {
					mmr_modify = TRUE;
				}
				main_z80mode = TRUE;
			}
			else {
				if (main_z80mode) {
					mmr_modify = TRUE;
				}
				main_z80mode = FALSE;
			}
#endif
			if (dat & 0x80) {
				/* TuHALTNGXg */
				subhalt_request = TRUE;
			}
			else {
				/* TuRUNNGXg */
				subhalt_request = FALSE;

				/* oN؂ւ́AZbg */
#if XM7_VER >= 3

				if (subreset_halt) {
					subcpu_reset();
					subreset_halt = FALSE;
				}
#endif
			}
			if (dat & 0x40) {
				/* LZIRQ */
				subcancel_request = TRUE;
			}
			subcpu_irq();
			return TRUE;

		/* Tu[h؂ւ */
#if XM7_VER >= 2
		case 0xfd12:
			if (fm7_ver >= 2) {
				/* ʃ[h؂ւꍇĕ` */
				if (dat & 0x40) {
					if (!mode320) {
						mode320 = TRUE;
						display_setpointer(TRUE);
					}
				}
				else {
					if (mode320) {
						mode320 = FALSE;
						display_setpointer(TRUE);
					}
				}
			}
			return TRUE;

		/* TuoN؂ւ */
		case 0xfd13:
			if (fm7_ver >= 2) {
				/* oN؂ւ */
#if XM7_VER >= 3
				if ((fm7_ver >= 3) && (dat & 0x04)) {
					subrom_bank = 4;
				}
				else {
					subrom_bank = (BYTE)(dat & 0x03);
				}
#else
				subrom_bank = (BYTE)(dat & 0x03);
#endif

				/* Zbg */
#if XM7_VER >= 3
				if (!subhalt_flag) {
					subcpu_reset();
					subreset_halt = FALSE;
				}
				else {
					subreset_halt = TRUE;
				}
#else
				subcpu_reset();
#endif

				/* tOރZbg */
				subreset_flag = TRUE;
				subbusy_flag = TRUE;

				/* \nI/OZbg (FM77AV fvO) */
				aluline_reset();
				ttlpalet_reset();
				multipag_reset();

				/* CRTWX^Zbg */
				display_reset();
				display_notify();

				/* INS LED */
				ins_flag = FALSE;
			}
			return TRUE;
#endif
	}

	return FALSE;
}

/*
 *	TuCPURg[
 *	Z[u
 */
BOOL FASTCALL subctrl_save(int fileh)
{
	if (!file_bool_write(fileh, subhalt_flag)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, subbusy_flag)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, subcancel_flag)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, subattn_flag)) {
		return FALSE;
	}

	if (!file_write(fileh, shared_ram, 0x80)) {
		return FALSE;
	}

	if (!file_bool_write(fileh, subreset_flag)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_bool_write(fileh, mode320)) {
		return FALSE;
	}
#endif

	/* Ver7g */
	if (!file_bool_write(fileh, subhalt_request)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, subcancel_request)) {
		return FALSE;
	}

	/* Ver711g */
	if (!file_byte_write(fileh, busy_CLR_count)) {
		return FALSE;
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (!file_bool_write(fileh, mode400l)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, mode256k)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, subram_protect)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, subreset_halt)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, subkanji_flag)) {
		return FALSE;
	}
#endif

#if XM7_VER == 1 && defined(L4CARD)
	/* XM7 V1.1 / FM-77L4g */
	if (!file_bool_write(fileh, select_400line)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, subkanji_flag)) {
		return FALSE;
	}
#endif

	return TRUE;
}

/*
 *	TuCPURg[
 *	[h
 */
BOOL FASTCALL subctrl_load(int fileh, int ver)
{
	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &subhalt_flag)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &subbusy_flag)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &subcancel_flag)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &subattn_flag)) {
		return FALSE;
	}

	if (!file_read(fileh, shared_ram, 0x80)) {
		return FALSE;
	}

	if (!file_bool_read(fileh, &subreset_flag)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_bool_read(fileh, &mode320)) {
		return FALSE;
	}
#endif

	/* Ver7g */
#if XM7_VER >= 3
	if (((ver >= 700) && (ver <= 799)) || (ver >= 900)) {
#elif XM7_VER >= 2
	if (ver >= 700) {
#else
	if (ver >= 300) {
#endif
		if (!file_bool_read(fileh, &subhalt_request)) {
			return FALSE;
		}
		if (!file_bool_read(fileh, &subcancel_request)) {
			return FALSE;
		}
	}
	else {
		subhalt_request = subhalt_flag;
		subcancel_request = subcancel_flag;
	}

	/* Ver711g */
#if XM7_VER >= 3
	if (((ver >= 711) && (ver <= 799)) || (ver >= 911)) {
#elif XM7_VER >= 2
	if (ver >= 711) {
#else
	if (ver >= 300) {
#endif
		if (!file_byte_read(fileh, &busy_CLR_count)) {
			return FALSE;
		}
	}
	else {
		busy_CLR_count = 0;
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (ver < 800) {
		mode400l = FALSE;
		mode256k = FALSE;
		subif_dat = 0x08;
		subram_protect = FALSE;
		subreset_halt = FALSE;

		/* |C^\ */
		display_setpointer(TRUE);
		return TRUE;
	}

	if (!file_bool_read(fileh, &mode400l)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &mode256k)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &subram_protect)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &subreset_halt)) {
		return FALSE;
	}

	/* Ver9.06g */
	if (ver >= 906) {
		if (!file_bool_read(fileh, &subkanji_flag)) {
			return FALSE;
		}
	}
	else {
		if (mode400l) {
			subkanji_flag = TRUE;
		}
		else {
			subkanji_flag = FALSE;
		}
	}

	/* TuI/F Reg. ʃ[hA */
	subif_dat = 0x00;
	if (!mode400l) {
		subif_dat |= (BYTE)0x08;
	}
	if (mode256k) {
		subif_dat |= (BYTE)0x10;
	}
#endif

#if XM7_VER == 1 && defined(L4CARD)
	/* XM7 V1.1 / FM-77L4g */
	if (!file_bool_read(fileh, &select_400line)) {
		return FALSE;
	}
	/* 400CJ[h`FbN */
	if (select_400line && !detect_400linecard) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &subkanji_flag)) {
		return FALSE;
	}
#endif

	/* |C^\ */
	display_setpointer(TRUE);

	return TRUE;
}
