/*
 *	FM-7 EMULATOR "XM7"
 *
 *	Copyright (C) 1999-2019 ohD(Twitter:@xm6_original)
 *	Copyright (C) 2001-2019 Ryu Takegami (Twitter:@RyuTakegami)
 *
 *	[ TuCPU ]
 *
 *	RHG
 *	  2001.07.23()	V2łVRAMpmۗʂ96KBɖ߂
 *	  2001.11.05		V2$D800`$FFFFɃCgANZXƃj󂷂
 *						C
 *	  2003.11.20		XM7 V1.1Ή(Ⴊݑpc)
 *	  2007.01.13		V1.1400CeLXgtHg40EXpgROMC[W
 *						őpł悤ɕύX(命ɂ͊֌WȂ)
 *	  2010.06.09		@ʂI/Ö̃~[̈𔽉f悤ɕύX
 *	  2010.09.29		FM-8ROMC[WȂꍇɃhCuԍ/FMfB
 *						XvC̕\łȂɑΏ
 *	  2012.05.29		Xe[g[h400CJ[h̑݃`FbNp~
 *	  2017.05.05		FM-8/7[hVRAMANZXtO𗧂ĂɃuL
 *						OԊOVRAMANZXꍇAƂȂ悤ɋ
 *						ύX
 */

#include <stdlib.h>
#include <string.h>
#include "xm7.h"
#include "display.h"
#include "subctrl.h"
#include "device.h"
#include "keyboard.h"
#include "multipag.h"
#include "aluline.h"
#include "l4font.h"

/*
 *	O[o [N
 */
BYTE *vram_c;						/* VRAM(^CvC) $C000(oNL) */
BYTE *subrom_c;						/* ROM (^CvC) $2800 */
BYTE *sub_ram;						/* R\[RAM $1680 */
BYTE *sub_io;						/* TuCPU I/O   $0100 */
#if XM7_VER >= 3
BYTE *subramde;						/* RAM (TypeD/E) $2000 */
BYTE *subramcg;						/* RAM (tHg)$4000 */
BYTE *subramcn;						/* R\[  $2000 */
#endif

#if XM7_VER >= 2
BYTE *vram_b;						/* VRAM(^CvB) $C000(oNL) */
BYTE *subrom_a;						/* ROM (^CvA) $2000 */
BYTE *subrom_b;						/* ROM (^CvB) $2000 */
BYTE *subromcg;						/* ROM (tHg)$2000 */

BYTE subrom_bank;					/* TuVXeROMoN */
BYTE cgrom_bank;					/* CGROMoN */
#if XM7_VER >= 3
BYTE cgram_bank;					/* CGRAMoN */
BYTE consram_bank;					/* R\[RAMoN */
#endif	/* XM7_VER >= 3 */
#endif	/* XM7_VER >= 2 */

#if XM7_VER == 1
BYTE *subrom_8;						/* ROM (FM-8)    $2800 */
BYTE *subrampcg;					/* RAM (PCG)      $800 */
BOOL pcg_flag;						/* PCGtO */
BOOL pcg_enable;					/* PCGLtO */
#ifdef L4CARD
BYTE *tvram_c;						/* Text VRAM     $1000 */
BYTE *subrom_l4;					/* ROM(400C)$4800 */
BYTE *subcg_l4;						/* CG (400C)$1000 */
BOOL enable_400linecard;			/* 400CJ[hCl[u */
BOOL detect_400linecard;			/* 400CJ[htO */
BOOL detect_400linecard_tmp;		/* 400CJ[htO */
BOOL ankcg_force_internal = FALSE;	/* tHggptO */
#endif
BOOL subrom_xchg;					/* TuVXeύXLtO */
#endif


/*
 *	TuCPU
 *	
 */
BOOL FASTCALL submem_init(void)
{
	/* xASăNA */
	vram_c = NULL;
	subrom_c = NULL;
	sub_ram = NULL;
	sub_io = NULL;
#if XM7_VER == 1
	subrom_8 = NULL;
	subrampcg = NULL;
	pcg_flag = FALSE;
	pcg_enable = FALSE;
#endif

#if XM7_VER >= 2
	vram_b = NULL;
	subrom_a = NULL;
	subrom_b = NULL;
	subromcg = NULL;
#if XM7_VER >= 3
	subramde = NULL;
	subramcg = NULL;
	subramcn = NULL;
#endif
#endif

#if XM7_VER == 1 && defined(L4CARD)
	tvram_c = NULL;
	subrom_l4 = NULL;
	subcg_l4 = NULL;
#endif

	/* m(^CvC) */
#if XM7_VER >= 3
	vram_c = (BYTE *)malloc(0x30000);
#elif XM7_VER >= 2
	vram_c = (BYTE *)malloc(0x18000);
#else
	vram_c = (BYTE *)malloc(0xc000);
#endif
	if (vram_c == NULL) {
		return FALSE;
	}
	subrom_c = (BYTE *)malloc(0x2800);
	if (subrom_c == NULL) {
		return FALSE;
	}
#if XM7_VER == 1
	subrom_8 = (BYTE *)malloc(0x2800);
	if (subrom_8 == NULL) {
		return FALSE;
	}
#endif

	/* m(^CvA,B) */
#if XM7_VER >= 2
	vram_b = vram_c + 0xc000;
	subrom_a = (BYTE *)malloc(0x2000);
	if (subrom_a == NULL) {
		return FALSE;
	}
	subrom_b = (BYTE *)malloc(0x2000);
	if (subrom_b == NULL) {
		return FALSE;
	}
	subromcg = (BYTE *)malloc(0x2000);
	if (subromcg == NULL) {
		return FALSE;
	}

#if XM7_VER >= 3
	/* m(^CvD,E) */
	subramcn = (BYTE *)malloc(0x2000);
	if (subramcn == NULL) {
		return FALSE;
	}
	subramcg = (BYTE *)malloc(0x4000);
	if (subramcg == NULL) {
		return FALSE;
	}
	subramde = (BYTE *)malloc(0x2000);
	if (subramde == NULL) {
		return FALSE;
	}
#endif
#endif

	/* m() */
	sub_ram = (BYTE *)malloc(0x1680);
	if (sub_ram == NULL) {
		return FALSE;
	}
	sub_io = (BYTE *)malloc(0x0100);
	if (sub_io == NULL) {
		return FALSE;
	}

#if XM7_VER == 1
	/* m(PCG) */
	subrampcg = (BYTE *)malloc(0x0800);
	if (subrampcg == NULL) {
		return FALSE;
	}

#ifdef L4CARD
	/* m(L4) */
	tvram_c = (BYTE *)malloc(0x1000);
	if (tvram_c == NULL) {
		return FALSE;
	}
	subrom_l4 = (BYTE *)malloc(0x4800);
	if (subrom_l4 == NULL) {
		return FALSE;
	}
	subcg_l4 = (BYTE *)malloc(0x1000);
	if (subcg_l4 == NULL) {
		return FALSE;
	}
#endif
#endif

	/* ROMt@Cǂݍ */
	if (!file_load(SUBSYSC_ROM, subrom_c, 0x2800)) {
#if XM7_VER == 1
		available_fm7roms = FALSE;
#else
		return FALSE;
#endif
	}
#if XM7_VER >= 2
	if (!file_load(SUBSYSA_ROM, subrom_a, 0x2000)) {
		return FALSE;
	}
	if (!file_load(SUBSYSB_ROM, subrom_b, 0x2000)) {
		return FALSE;
	}
	if (!file_load(SUBSYSCG_ROM, subromcg, 0x2000)) {
		return FALSE;
	}
#endif

#if XM7_VER == 1
	if (!file_load(SUBSYS8_ROM, subrom_8, 0x2800)) {
		available_fm8roms = FALSE;
	}

#ifdef L4CARD
	/* 400CΉ */
	detect_400linecard_tmp = FALSE;
	if (!file_load(SUBSYSL4_ROM, subrom_l4, 0x4800)) {
		enable_400linecard = FALSE;
		detect_400linecard = FALSE;
	}
	else {
		enable_400linecard = TRUE;
		detect_400linecard = TRUE;

		/* ANKCG16.ROM,EXTSUB.ROM̂ǂȂꍇtHggp */
		if (ankcg_force_internal) {
			memcpy(subcg_l4, subcg_internal, 4096);
		}
		else {
			if (!file_load(ANKCG16_ROM, subcg_l4, 0x1000)) {
				if (!file_load(EXTSUB_ROM, subcg_l4, 0x1000)) {
					memcpy(subcg_l4, subcg_internal, 4096);
				}
			}
		}
	}
#endif

	if (!available_fm8roms && !available_fm7roms) {
		return FALSE;
	}

	/* PCGGȀ */
	memset(subrampcg, 0xff, 0x0800);

	/* FM-8ROMC[WȂꍇ̃hCuԍ\ւ̑Ώ */
	/* {A擪2048oCĝ݃Rs[΂悢ÔߑŜRs[ */
	if (available_fm8roms && !available_fm7roms) {
		memcpy(subrom_c, subrom_8, 0x2800);
	}

	/* TuVXeύXLtO */
	subrom_xchg = FALSE;
#endif

	return TRUE;
}

/*
 *	TuCPU
 *	N[Abv
 */
void FASTCALL submem_cleanup(void)
{
/*
	ASSERT(vram_c);
	ASSERT(subrom_c);
	ASSERT(sub_ram);
	ASSERT(sub_io);
#if XM7_VER >= 2
	ASSERT(subrom_a);
	ASSERT(subrom_b);
	ASSERT(subromcg);
#if XM7_VER >= 3
	ASSERT(subramcn);
	ASSERT(subramcg);
	ASSERT(subramde);
#endif
#endif
#if XM7_VER == 1
	ASSERT(subrom_8);
	ASSERT(subrampcg);
#ifdef L4CARD
	ASSERT(tvram_c);
	ASSERT(subrom_l4);
	ASSERT(subcg_l4);
#endif
#endif
*/

	/* rŎsꍇl */
	if (vram_c) {
		free(vram_c);
	}
	if (subrom_c) {
		free(subrom_c);
	}

#if XM7_VER >= 2
	if (subrom_a) {
		free(subrom_a);
	}
	if (subrom_b) {
		free(subrom_b);
	}
	if (subromcg) {
		free(subromcg);
	}

#if XM7_VER >= 3
	if (subramcn) {
		free(subramcn);
	}
	if (subramcg) {
		free(subramcg);
	}
	if (subramde) {
		free(subramde);
	}
#endif
#endif

	if (sub_ram) {
		free(sub_ram);
	}
	if (sub_io) {
		free(sub_io);
	}

#if XM7_VER == 1
	if (subrom_8) {
		free(subrom_8);
	}
	if (subrampcg) {
		free(subrampcg);
	}

#ifdef L4CARD
	if (tvram_c) {
		free(tvram_c);
	}
	if (subrom_l4) {
		free(subrom_l4);
	}
	if (subcg_l4) {
		free(subcg_l4);
	}
#endif
#endif
}

/*
 *	TuCPU
 *	Zbg
 */
void FASTCALL submem_reset(void)
{
#if XM7_VER >= 2
	/* VRAMANeBuy[W */
	vram_aptr = vram_c;
	vram_active = 0;

	/* oNNA */
	subrom_bank = 0;
	cgrom_bank = 0;
#if XM7_VER >= 3
	cgram_bank = 0;
	consram_bank = 0;
#endif
#endif

	/* I/O NA */
	memset(sub_io, 0xff, 0x0100);
}

/*
 *	TuCPU
 *	PoCg擾
 */
BYTE FASTCALL submem_readb(WORD addr)
{
	BYTE dat;

#if XM7_VER == 1 && defined(L4CARD)
	/* FM-77L4 400C[h̏ */
	if (enable_400line && enable_400linecard) {
		/* GVRAM/[NRAM */
		if (addr <= 0x7fff) {
			/* [NRAM */
			if (workram_select) {
				if (multi_page & 4) {
					return 0xff;
				}
				return vram_c[0x8000 + ((addr + vram_offset[0]) & 0x3fff)];
			}

			/* GVRAM */
			addr += vram_offset[0];
			addr &= 0x7fff;
			if (multi_page & (1 << (addr >> 14))) {
				return 0xff;
			}
			return vram_c[addr];
		}

		/* eLXgVRAM */
		if ((addr >= 0x8000) && (addr <= 0x97ff)) {
			return tvram_c[addr & 0xfff];
		}

		/* Tuj^ROM(O) */
		if ((addr >= 0x9800) && (addr <= 0xbfff)) {
			return subrom_l4[addr - 0x9800];
		}

		/* Tuj^ROM(㔼) */
		if (addr >= 0xe000) {
			return subrom_l4[addr - 0xb800];
		}
	}
#endif

	/* VRAM */
	if (addr < 0xc000) {
#if XM7_VER >= 3
		if ((fm7_ver >= 2) || (cycle_steal || vrama_flag || blank_flag)) {
			if (mode400l) {
				/* 400C */
				if (addr >= 0x8000) {
					return 0xff;
				}
				aluline_extrb(addr);

				if (multi_page & (1 << subram_vrambank)) {
					return 0xff;
				}
				else {
					return vram_aptr[addr];
				}
			}
			else {
				/* 200C */
				aluline_extrb(addr);
				if (multi_page & (1 << (addr >> 14))) {
					return 0xff;
				}
				else {
					return vram_aptr[((addr & 0xc000) << 1) | (addr & 0x3fff)];
				}
			}
		}
		else {
			return 0xff;
		}
#elif XM7_VER >= 2
		/* 200C */
		if ((fm7_ver >= 2) || (cycle_steal || vrama_flag || blank_flag)) {
			aluline_extrb(addr);
			if (multi_page & (1 << (addr >> 14))) {
				return 0xff;
			}
			else {
				return vram_aptr[addr];
			}
		}
		else {
			return 0xff;
		}
#else
		/* 200C */
		if ((fm_subtype == FMSUB_FM77) ||
			(cycle_steal || vrama_flag || blank_flag)) {
			if (multi_page & (1 << (addr >> 14))) {
				return 0xff;
			}
			else {
				return vram_c[addr];
			}
		}
		else {
			return 0xff;
		}
#endif
	}

#if XM7_VER >= 3
	/* R\[RAM(RAM[hp) */
	if ((addr < 0xd000) && (subrom_bank == 4) && (consram_bank >= 1)) {
		return subramcn[(consram_bank - 1) * 0x1000 + (addr - 0xc000)];
	}
#endif

	/* [NRAM */
	if (addr < 0xd380) {
		return sub_ram[addr - 0xc000];
	}

	/* LRAM */
	if (addr < 0xd400) {
		return shared_ram[(WORD)(addr - 0xd380)];
	}

#if XM7_VER >= 2
	/* TuROM */
	if (addr >= 0xe000) {
		switch (subrom_bank) {
			/* ^CvC */
			case 0:
				return subrom_c[addr - 0xd800];
			/* ^CvA */
			case 1:
				return subrom_a[addr - 0xe000];
			/* ^CvB */
			case 2:
				return subrom_b[addr - 0xe000];
			/* CGROM */
			case 3:
				return subromcg[addr - 0xe000];
#if XM7_VER >= 3
			/* ^CvD/E(RAM) */
			case 4:
				return subramde[addr - 0xe000];
#endif
			}
	}

	/* CGRAM,CGROM */
	if (addr >= 0xd800) {
#if XM7_VER >= 3
		if (subrom_bank == 4) {
			/* TuRAM oN */
			return subramcg[cgram_bank * 0x0800 + (addr - 0xd800)];
		}
		else if (fm7_ver >= 2) {
			/* TuROM oN */
			return subromcg[cgrom_bank * 0x0800 + (addr - 0xd800)];
		}
		else {
			/* TuROM Type-C */
			return subrom_c[addr - 0xd800];
		}
#else
		if (fm7_ver >= 2) {
			/* TuROM oN */
			return subromcg[cgrom_bank * 0x0800 + (addr - 0xd800)];
		}
		else {
			/* TuROM Type-C */
			return subrom_c[addr - 0xd800];
		}
#endif
	}

	/* [NRAM */
	if (fm7_ver >= 2) {
		if (addr >= 0xd500){
			return sub_ram[(addr - 0xd500) + 0x1380];
		}
	}
#else
	if (addr >= 0xd800) {
		if ((addr < 0xe000) && pcg_flag && pcg_enable) {
			/* PCG */
			return subrampcg[addr - 0xd800];
		}
		if ((fm_subtype == FMSUB_FM8) && !subrom_xchg) {
			/* FM-8Tuj^ */
			return subrom_8[addr - 0xd800];
		}
		else {
			/* ^CvC */
			return subrom_c[addr - 0xd800];
		}\
	}
#endif

	/*
	 *	TuI/O
	 */
#if XM7_VER == 1
	/* $D410`$D7FF$D400`$D40F̃~[ */
	addr &= 0xfc0f;
#else
	if (fm7_ver == 1) {
		/* $D410`$D7FF$D400`$D40F̃~[ */
		addr &= 0xfc0f;
	}
	else if (fm7_ver == 2) {
		/* $D440`$D4FF$D400`$D43F̃~[ */
		addr &= 0xff3f;
	}
#endif

	/* fBXvC */
	if (display_readb(addr, &dat)) {
		return dat;
	}
	/* L[{[h */
	if (keyboard_readb(addr, &dat)) {
		return dat;
	}
	/* _ZE */
#if XM7_VER >= 2
	if (aluline_readb(addr, &dat)) {
		return dat;
	}
#endif

	return 0xff;
}

/*
 *	TuCPU
 *	PoCg擾(I/OȂ)
 */
BYTE FASTCALL submem_readbnio(WORD addr)
{
#if XM7_VER == 1 && defined(L4CARD)
	/* FM-77L4 400C[h̏ */
	if (enable_400line && enable_400linecard) {
		/* GVRAM/[NRAM */
		if (addr <= 0x7fff) {
			/* [NRAM */
			if (workram_select) {
				if (multi_page & 4) {
					return 0xff;
				}
				return vram_c[0x8000 + ((addr + vram_offset[0]) & 0x3fff)];
			}

			/* GVRAM */
			addr += vram_offset[0];
			addr &= 0x7fff;
			if (multi_page & (1 << (addr >> 14))) {
				return 0xff;
			}
			return vram_c[addr];
		}

		/* eLXgVRAM */
		if ((addr >= 0x8000) && (addr <= 0x97ff)) {
			return tvram_c[addr & 0xfff];
		}

		/* Tuj^ROM(O) */
		if ((addr >= 0x9800) && (addr <= 0xbfff)) {
			return subrom_l4[addr - 0x9800];
		}

		/* Tuj^ROM(㔼) */
		if (addr >= 0xe000) {
			return subrom_l4[addr - 0xb800];
		}
	}
#endif

	/* VRAM */
	if (addr < 0xc000) {
#if XM7_VER >= 3
		if (mode400l) {
			/* 400C */
			if (addr < 0x8000) {
				return vram_aptr[addr];
			}
			else {
				return 0xff;
			}
		}
		else {
			/* 200C */
			return vram_aptr[((addr & 0xc000) << 1) | (addr & 0x3fff)];
		}
#elif XM7_VER >= 2
		/* 200C */
		return vram_aptr[addr];
#else
		/* 200C */
		return vram_c[addr];
#endif
	}

#if XM7_VER >= 3
	/* R\[RAM(RAM[hp) */
	if ((addr < 0xd000) && (subrom_bank == 4) && (consram_bank >= 1)) {
		return subramcn[(consram_bank - 1) * 0x1000 + (addr - 0xc000)];
	}
#endif

	/* [NRAM */
	if (addr < 0xd380) {
		return sub_ram[addr - 0xc000];
	}

	/* LRAM */
	if (addr < 0xd400) {
		return shared_ram[(WORD)(addr - 0xd380)];
	}

	/* [NRAM */
#if XM7_VER >= 2
	if (fm7_ver >= 2) {
		if ((addr >= 0xd500) && (addr < 0xd800)) {
			return sub_ram[(addr - 0xd500) + 0x1380];
		}
	}
#endif

	/* TuI/O */
	if (addr < 0xd800) {
#if XM7_VER == 1
		/* $D410`$D7FF$D400`$D40F̃~[ */
		addr &= 0xfc0f;
#else
		if (fm7_ver == 1) {
			/* $D410`$D7FF$D400`$D40F̃~[ */
			addr &= 0xfc0f;
		}
		else if (fm7_ver == 2) {
			/* $D440`$D4FF$D400`$D43F̃~[ */
			addr &= 0xff3f;
		}
#endif
		return sub_io[addr - 0xd400];
	}

#if XM7_VER >= 2
	/* TuROM */
	if (addr >= 0xe000) {
		ASSERT(subrom_bank <= 4);
		switch (subrom_bank) {
			/* ^CvC */
			case 0:
				return subrom_c[addr - 0xd800];
			/* ^CvA */
			case 1:
				return subrom_a[addr - 0xe000];
			/* ^CvB */
			case 2:
				return subrom_b[addr - 0xe000];
			/* CGROM */
			case 3:
				return subromcg[addr - 0xe000];
#if XM7_VER >= 3
			/* ^CvD/E(RAM) */
			case 4:
				return subramde[addr - 0xe000];
#endif
			}
	}

	/* CGRAM,CGROM */
	if (addr >= 0xd800) {
#if XM7_VER >= 3
		if (subrom_bank == 4) {
			/* TuRAM oN */
			return subramcg[cgram_bank * 0x0800 + (addr - 0xd800)];
		}
		else if (fm7_ver >= 2) {
			/* TuROM oN */
			return subromcg[cgrom_bank * 0x0800 + (addr - 0xd800)];
		}
		else {
			/* TuROM Type-C */
			return subrom_c[addr - 0xd800];
		}
#else
		if (fm7_ver >= 2) {
			/* TuROM oN */
			return subromcg[cgrom_bank * 0x0800 + (addr - 0xd800)];
		}
		else {
			/* TuROM Type-C */
			return subrom_c[addr - 0xd800];
		}
#endif
	}
#else
	if (addr >= 0xd800) {
		if ((addr < 0xe000) && pcg_flag && pcg_enable) {
			/* PCG */
			return subrampcg[addr - 0xd800];
		}
		if ((fm_subtype == FMSUB_FM8) && !subrom_xchg) {
			/* FM-8Tuj^ */
			return subrom_8[addr - 0xd800];
		}
		else {
			/* ^CvC */
			return subrom_c[addr - 0xd800];
		}
	}
#endif

	/* ɂ͗Ȃ */
	ASSERT(FALSE);
	return 0;
}

/*
 *	TuCPU
 *	PoCg
 */
void FASTCALL submem_writeb(WORD addr, BYTE dat)
{
#if XM7_VER == 1 && defined(L4CARD)
	/* FM-77L4 400C[h̏ */
	if (enable_400line && enable_400linecard) {
		/* GVRAM/[NRAM */
		if (addr <= 0x7fff) {
			/* [NRAM */
			if (workram_select) {
				if (!(multi_page & 4)) {
					vram_c[0x8000 + ((addr + vram_offset[0]) & 0x3fff)] = dat;
				}
				return;
			}

			/* GVRAM */
			addr += vram_offset[0];
			addr &= 0x7fff;
			if (!(multi_page & (1 << (addr >> 14)))) {
				/* f[^ނȂANotifyȂ */
				if (vram_c[addr] != dat) {
					vram_c[addr] = dat;
					vram_notify(addr, dat);
				}
			}
			return;
		}

		/* eLXgVRAM */
		if ((addr >= 0x8000) && (addr <= 0x97ff)) {
			tvram_c[addr & 0xfff] = dat;
			tvram_notify((WORD)(addr & 0xfff), dat);
			return;
		}

		/* Tuj^ROM */
		if (((addr >= 0x9800) && (addr <= 0xbfff)) || (addr >= 0xe000)) {
			return;
		}
	}
#endif

	/* VRAM(^CvC) */
	if (addr < 0xc000) {
#if XM7_VER >= 3
		if ((fm7_ver >= 2) || (cycle_steal || vrama_flag || blank_flag)) {
			if (mode400l) {
				/* 400C */
				if (addr >= 0x8000) {
					return;
				}
				if (alu_command & 0x80) {
					aluline_extrb(addr);
					return;
				}
				if (!(multi_page & (1 << subram_vrambank))) {
					if (vram_aptr[addr] != dat) {
						/* f[^ނȂANotifyȂ */
						vram_aptr[addr] = dat;
						vram_notify(addr, dat);
					}
				}
			}
			else {
				if (alu_command & 0x80) {
					aluline_extrb(addr);
					return;
				}
				if (!(multi_page & (1 << (addr >> 14)))) {
					/* f[^ނȂANotifyȂ */
					if (vram_aptr[((addr & 0xc000) << 1)|(addr & 0x3fff)] != dat) {
						vram_aptr[((addr & 0xc000) << 1)|(addr & 0x3fff)] = dat;
						vram_notify(addr, dat);
					}
				}
			}
		}
#elif XM7_VER >= 2
		if ((fm7_ver >= 2) || (cycle_steal || vrama_flag || blank_flag)) {
			if (alu_command & 0x80) {
				aluline_extrb(addr);
				return;
			}
			if (!(multi_page & (1 << (addr >> 14)))) {
				/* f[^ނȂANotifyȂ */
				if (vram_aptr[addr] != dat) {
					vram_aptr[addr] = dat;
					vram_notify(addr, dat);
				}
			}
		}
#else
		if ((fm_subtype == FMSUB_FM77) ||
			(cycle_steal || vrama_flag || blank_flag)) {
			if (!(multi_page & (1 << (addr >> 14)))) {
				/* f[^ނȂANotifyȂ */
				if (vram_c[addr] != dat) {
					vram_c[addr] = dat;
					vram_notify(addr, dat);
				}
			}
		}
#endif
		return;
	}

#if XM7_VER >= 3
	/* R\[RAM(RAM[hp) */
	if ((addr < 0xd000) && (subrom_bank == 4) && (consram_bank >= 1)) {
		subramcn[(consram_bank - 1) * 0x1000 + (addr - 0xc000)] = dat;
		return;
	}
#endif

	/* [NRAM */
	if (addr < 0xd380) {
		sub_ram[addr - 0xc000] = dat;
		return;
	}

	/* LRAM */
	if (addr < 0xd400) {
		shared_ram[(WORD)(addr - 0xd380)] = dat;
		return;
	}

	/* [NRAM */
#if XM7_VER >= 2
	if (fm7_ver >= 2) {
		if ((addr >= 0xd500) && (addr < 0xd800)) {
			sub_ram[(addr - 0xd500) + 0x1380] = dat;
			return;
		}
	}
#endif

	/* CGROM,TuRAM ROM[hł͏݂łȂ */
	if (addr >= 0xd800) {
#if XM7_VER >= 3
		/* TuRAMłȂAveNgĂ */
		if ((subrom_bank != 4) || subram_protect) {
			return;
		}

		/* CGRAM */
		if (addr < 0xe000) {
			subramcg[cgram_bank * 0x0800 + (addr - 0xd800)] = dat;
			return;
		}

		/* TuRAM */
		subramde[addr - 0xe000] = dat;
		return;
#else
#if XM7_VER == 1
		/* PCG */
		if ((addr < 0xe000) && pcg_enable) {
			/* ROM/RAMǂł݉ */
			subrampcg[addr - 0xd800] = dat;
			return;
		}
#endif

		/* V1/V2ł͖ŏݕs */
		return;
#endif
	}

	/*
	 *	TuI/O
	 */
#if XM7_VER == 1
	/* $D410`$D7FF$D400`$D40F̃~[ */
	addr &= 0xfc0f;
#else
	if (fm7_ver == 1) {
		/* $D410`$D7FF$D400`$D40F̃~[ */
		addr &= 0xfc0f;
	}
	else if (fm7_ver == 2) {
		/* $D440`$D4FF$D400`$D43F̃~[ */
		addr &= 0xff3f;
	}
#endif
	sub_io[addr - 0xd400] = dat;

	/* fBXvC */
	if (display_writeb(addr, dat)) {
		return;
	}
	/* L[{[h */
	if (keyboard_writeb(addr, dat)) {
		return;
	}
	/* _ZE */
#if XM7_VER >= 2
	if (aluline_writeb(addr, dat)) {
		return;
	}
#endif
}

/*
 *	TuCPU
 *	Z[u
 */
BOOL FASTCALL submem_save(int fileh)
{
#if XM7_VER >= 3
	/* ܂łƓŏ */
	if (mode400l) {
		if (!file_write(fileh, vram_c, 0x18000)) {
			return FALSE;
		}
	}
	else {
		if (!file_write(fileh, vram_c, 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x8000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x10000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x4000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0xc000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x14000], 0x4000)) {
			return FALSE;
		}
	}
#else
	if (!file_write(fileh, vram_c, 0x6000)) {
		return FALSE;
	}
	if (!file_write(fileh, &vram_c[0x6000], 0x6000)) {
		return FALSE;
	}
#if XM7_VER >= 2
	if (!file_write(fileh, &vram_c[0xc000], 0x6000)) {
		return FALSE;
	}
	if (!file_write(fileh, &vram_c[0x12000], 0x6000)) {
		return FALSE;
	}
#endif
#endif

	if (!file_write(fileh, sub_ram, 0x1680)) {
		return FALSE;
	}

	if (!file_write(fileh, sub_io, 0x100)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_byte_write(fileh, subrom_bank)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, cgrom_bank)) {
		return FALSE;
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (mode400l) {
		if (!file_write(fileh, &vram_c[0x18000], 0x18000)) {
			return FALSE;
		}
	}
	else {
		if (!file_write(fileh, &vram_c[0x18000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x20000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x28000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x1c000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x24000], 0x4000)) {
			return FALSE;
		}
		if (!file_write(fileh, &vram_c[0x2c000], 0x4000)) {
			return FALSE;
		}
	}

	if (!file_write(fileh, subramde, 0x2000)) {
		return FALSE;
	}
	if (!file_write(fileh, subramcg, 0x4000)) {
		return FALSE;
	}
	if (!file_write(fileh, subramcn, 0x2000)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, cgram_bank)) {
		return FALSE;
	}
	if (!file_byte_write(fileh, consram_bank)) {
		return FALSE;
	}
#endif
#endif

#if XM7_VER == 1 && defined(L4CARD)
	if (!file_write(fileh, tvram_c, 0x1000)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, detect_400linecard)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, enable_400linecard)) {
		return FALSE;
	}
	if (!file_write(fileh, subrampcg, 0x0800)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, pcg_flag)) {
		return FALSE;
	}
	if (!file_bool_write(fileh, subrom_xchg)) {
		return FALSE;
	}
#endif

	return TRUE;
}

/*
 *	TuCPU
 *	[h
 */
BOOL FASTCALL submem_load(int fileh, int ver)
{
#if XM7_VER == 1
	BOOL tmp;
#endif

	/* o[W`FbN */
	if (ver < 200) {
		return FALSE;
	}

#if XM7_VER >= 3
	/* ܂łƓœǂݏo */
	if (!file_read(fileh, vram_c, 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x8000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x10000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x4000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0xc000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x14000], 0x4000)) {
		return FALSE;
	}
#else
	if (!file_read(fileh, vram_c, 0x6000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x6000], 0x6000)) {
		return FALSE;
	}
#if XM7_VER >= 2
	if (!file_read(fileh, &vram_c[0xc000], 0x6000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x12000], 0x6000)) {
		return FALSE;
	}
#endif
#endif

	if (!file_read(fileh, sub_ram, 0x1680)) {
		return FALSE;
	}

	if (!file_read(fileh, sub_io, 0x100)) {
		return FALSE;
	}

#if XM7_VER >= 2
	if (!file_byte_read(fileh, &subrom_bank)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &cgrom_bank)) {
		return FALSE;
	}

#if XM7_VER >= 3
	/* Ver8g */
	if (ver < 800) {
		consram_bank = 0;
		cgram_bank = 0;
		return TRUE;
	}

	/* ܂łƓœǂݏo */
	if (!file_read(fileh, &vram_c[0x18000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x20000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x28000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x1c000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x24000], 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, &vram_c[0x2c000], 0x4000)) {
		return FALSE;
	}

	if (!file_read(fileh, subramde, 0x2000)) {
		return FALSE;
	}
	if (!file_read(fileh, subramcg, 0x4000)) {
		return FALSE;
	}
	if (!file_read(fileh, subramcn, 0x2000)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &cgram_bank)) {
		return FALSE;
	}
	if (!file_byte_read(fileh, &consram_bank)) {
		return FALSE;
	}
#endif
#endif

#if XM7_VER == 1 && defined(L4CARD)
	if (!file_read(fileh, tvram_c, 0x1000)) {
		return FALSE;
	}
	if (!file_bool_read(fileh, &detect_400linecard_tmp)) {
		return FALSE;
	}

	/* Ver3.06g */
	if (ver >= 306) {
		if (!file_bool_read(fileh, &enable_400linecard)) {
			return FALSE;
		}
	}
#endif

#if XM7_VER == 1
#ifdef L4CARD
	/* Ver3.10g */
	if (ver >= 310) {
#else
	/* Ver3.12g */
	if (ver >= 312) {
#endif
		if (!file_read(fileh, subrampcg, 0x0800)) {
			return FALSE;
		}
	}

	/* Ver3.12g */
	if (ver >= 312) {
		if (!file_bool_read(fileh, &pcg_flag)) {
			return FALSE;
		}
	}

	/* Ver3.14g */
	if (ver >= 314) {
		if (!file_bool_read(fileh, &tmp)) {
			return FALSE;
		}
	}
	else {
		tmp = FALSE;
	}
	if (available_fm7roms) {
		subrom_xchg = tmp;
	}
	else {
		subrom_xchg = FALSE;
	}
#endif

	return TRUE;
}
